{Tera Term
 Copyright(C) 1994-1996 T. Teranishi
 All rights reserved.}

{TERATERM.EXE, main}
program TeraTerm;
{$R teraterm.res}
{$I teraterm.inc}

{$IFDEF Delphi}
uses Messages, WinTypes, WinProcs, OWindows, VTWin, TEK, TTWinMan,
     TTCommon, Telnet, FileSys, TTTypes, Clipboard, TTDDE, CommLib;
{$ELSE}
uses WinTypes, WinProcs, WObjects, VTWin, TEK, TTWinMan, TTCommon, Telnet,
     FileSys, TTTypes, Clipboard, TTDDE, CommLib;
{$ENDIF}

const
  Id_Accs = 100;

type
  TeraAppli = object(TApplication)
    procedure InitMainWindow; virtual;
    procedure InitInstance; virtual;
    procedure MessageLoop; virtual;
    function CanClose: boolean; virtual;
    function ProcessAccels(var Message: TMsg): Boolean; virtual;
  end;

procedure TeraAppli.InitMainWindow;
begin
  MainWindow := New(PVTWindow, Init(nil));
  VTPtr := PVTWindow(MainWindow);
end;

procedure TeraAppli.InitInstance;
begin
  TApplication.InitInstance;
  HAccTable := LoadAccelerators(HInstance, PChar(id_Accs));
end;

procedure TeraAppli.MessageLoop;
var
  Msg: TMsg;
  Busy: integer;
  c, ChangeEmu: integer;
  b: byte;
begin
  while True do
  begin
    if GetMessage(Msg,0,0,0) then
    begin
      if not ProcessAppMsg(Msg) then
      begin
        TranslateMessage(Msg);
        DispatchMessage(Msg);
      end;
    end
    else begin
      Status := Msg.WParam;
      exit;
    end;

    Busy := 2;
    repeat
      if cv.Ready then
      begin

      {Sender}
      CommSend(@cv);

      {Parser}
      if (cv.HLogBuf<>0) and (cv.LogBuf=nil) then
        cv.LogBuf := GlobalLock(cv.HLogBuf);

      if (cv.HBinBuf<>0) and (cv.BinBuf=nil) then
        cv.BinBuf := GlobalLock(cv.HBinBuf);

      if (TelStatus=TelIdle) and cv.TelMode then
        TelStatus := TelIAC;

      if TelStatus<>TelIdle then
      begin
        ParseTel;
        if TelnetRec.ChangeWinSize then
          VTPtr^.ChangeTerminalSize(TelnetRec.WinSize.X,
                                    TelnetRec.WinSize.Y);
      end
      else begin
        if ProtoFlag then ChangeEmu := ProtoDlgParse
        else begin
          case ActiveWin of
            IdVT: ChangeEmu := VTPtr^.Parse;
            IdTEK: ChangeEmu := TEKPtr^.Parse;
          else
            ChangeEmu := 0;
          end;
        end;
        case ChangeEmu of
          IdVT: VTActivate;
          IdTEK: TEKActivate;
        end;
      end;

      if cv.LogBuf<>nil then
      begin
        if FileLog then LogToFile;
        if DDELog and AdvFlag then DDEAdv;
        GlobalUnlock(cv.HLogBuf);
        cv.LogBuf := nil;
      end;

      if cv.BinBuf<>nil then
      begin
        if BinLog then LogToFile;
        GlobalUnlock(cv.HBinBuf);
        cv.BinBuf := nil;
      end;

      {Talker}
      case TalkStatus of
        IdTalkCB: CBSend;         {clip board}
        IdTalkFile: FileSend;     {file}
      end;

      {Receiver}
      CommReceive(@cv);

      end;

      if PeekMessage(Msg, 0, 0, 0, pm_Remove) then
      begin
        if Msg.Message = wm_Quit then
        begin
          Status := Msg.WParam;
          Exit;
        end;
        if not ProcessAppMsg(Msg) then
        begin
          TranslateMessage(Msg);
          DispatchMessage(Msg);
        end;
      end;

      with cv do
        if Ready and
           ( RRQ or (OutBuffCount>0) or
             (LCount>0) or (BCount>0) or (DCount>0) ) then
          Busy := 2
        else
          dec(Busy);
    until not cv.Ready or (Busy<=0);

  end;
end;

function TeraAppli.CanClose: boolean;
begin
  CanClose := false;
  if (HTEKWin<>0) and not IsWindowEnabled(HTEKWin)
  then begin
    messagebeep(0);
    exit;
  end;

  if cv.Ready and (cv.PortType=IdTCPIP) and
     (ts.ConfirmDisconn<>0) and
     (messagebox(HMainWin,'Disconnect?','Tera Term',mb_YesNo)=IdNo)
  then exit;

  CanClose := true;
end;

function TeraAppli.ProcessAccels(var Message: TMsg): Boolean;
begin
  if ts.MetaKey>0 then
    ProcessAccels := false {ignore accelerator keys}
  else
    ProcessAccels := TApplication.ProcessAccels(Message);
end;

var
  Tera: TeraAppli;

begin
  Tera.Init('Tera Term');
  Tera.Run;
  Tera.Done;
end.