{Tera Term
 Copyright(C) 1994-1996 T. Teranishi
 All rights reserved.}

{TERATERM.EXE, TTDLG interface}
unit TTDialog;

interface

uses WinTypes, WinProcs, TTTypes;

type

TSetupTerminal = function(WndParent: HWnd; ts: PTTSet; Language: Word): BOOL;
TSetupWin = function(WndParent: HWnd; ts: PTTSet): BOOL;
TSetupKeyboard = function(WndParent: HWnd; ts: PTTSet; Language: Word): BOOL;
TSetupSerialPort= function(WndParent: HWnd; ts: PTTSet): BOOL;
TSetupTCPIP = function(WndParent: HWnd; ts: PTTSet): BOOL;
TGetHostName = function(WndParent: HWnd; GetHNRec: PGetHNRec): BOOL;
TChangeDirectory = function(WndParent: HWnd; CurDir: PChar): BOOL;
TAboutDialog = function(WndParent: HWnd): BOOL;
TChooseFontDlg = function(WndParent: HWnd; LogFont: PLogFont; Bold: PWord): BOOL;
TSetupGeneral = function(WndParent: HWnd; Port, Language: PWord): BOOL;

var
  HTTDLG: THandle;
  TTDLGUseCount: integer;

  SetupTerminal: TSetupTerminal;
  SetupWin: TSetupWin;     
  SetupKeyboard: TSetupKeyboard;
  SetupSerialPort: TSetupSerialPort;
  SetupTCPIP: TSetupTCPIP;
  GetHostName: TGetHostName;    
  ChangeDirectory: TChangeDirectory;
  AboutDialog: TAboutDialog;
  ChooseFontDlg: TChooseFontDlg;
  SetupGeneral: TSetupGeneral;

function LoadTTDLG: BOOL;
procedure FreeTTDLG;

implementation

const
  IdSetupTerminal   = 1;
  IdSetupWin        = 2;
  IdSetupKeyboard   = 3;
  IdSetupSerialPort = 4;
  IdSetupTCPIP      = 5;
  IdGetHostName     = 6;
  IdChangeDirectory = 7;
  IdAboutDialog     = 8;
  IdChooseFontDlg   = 9;
  IdSetupGeneral    = 10;

function LoadTTDLG: BOOL;
var
  Err: Boolean;
begin
  LoadTTDLG := false;

  if HTTDLG < 32 then
  begin
    TTDLGUseCount := 0;

    HTTDLG := LoadLibrary('TTDLG.DLL');
    if HTTDLG < 32 then exit;

    Err := false;
    @SetupTerminal := GetProcAddress(HTTDLG, PChar(IdSetupTerminal));
    if @SetupTerminal=nil then Err := true;

    @SetupWin := GetProcAddress(HTTDLG, PChar(IdSetupWin));
    if @SetupWin=nil then Err := true;

    @SetupKeyboard := GetProcAddress(HTTDLG, PChar(IdSetupKeyboard));
    if @SetupKeyboard=nil then Err := true;

    @SetupSerialPort := GetProcAddress(HTTDLG, PChar(IdSetupSerialPort));
    if @SetupSerialPort=nil then Err := true;

    @SetupTCPIP := GetProcAddress(HTTDLG, PChar(IdSetupTCPIP));
    if @SetupTCPIP=nil then Err := true;

    @GetHostName := GetProcAddress(HTTDLG, PChar(IdGetHostName));
    if @GetHostName=nil then Err := true;

    @ChangeDirectory := GetProcAddress(HTTDLG, PChar(IdChangeDirectory));
    if @ChangeDirectory=nil then Err := true;

    @AboutDialog := GetProcAddress(HTTDLG, PChar(IdAboutDialog));
    if @AboutDialog=nil then Err := true;

    @ChooseFontDlg := GetProcAddress(HTTDLG, PChar(IdChooseFontDlg));
    if @ChooseFontDlg=nil then Err := true;

    @SetupGeneral := GetProcAddress(HTTDLG, PChar(IdSetupGeneral));
    if @SetupGeneral=nil then Err := true;

    if Err then
    begin
      FreeLibrary(HTTDLG);
      HTTDLG := 0;
      exit;
    end;
  end;
  inc(TTDLGUseCount);
  LoadTTDLG := true;
end;

procedure FreeTTDLG;
begin
  if TTDLGUseCount=0 then exit;
  dec(TTDLGUseCount);
  if TTDLGUseCount>0 then exit;
  if HTTDLG >= 32 then
  begin
    FreeLibrary(HTTDLG);
    HTTDLG := 0;
  end;
end;


begin
  HTTDLG := 0;
  TTDLGUseCount := 0;
end.