{Tera Term
 Copyright(C) 1994-1996 T. Teranishi
 All rights reserved.}

{TTMACRO.EXE, main}
program TTMACRO;
{$R ttmacro.res}
{$I teraterm.inc}

{$IFDEF Delphi}
uses Messages, WinTypes, WinProcs, OWindows, ODialogs, Strings, DDEML,
     TTMDDE, TTL, TTMParse, TTMDLG;
{$ELSE}
uses WinTypes, WinProcs, WObjects, Strings, DDEML, Win31,
     TTMDDE, TTL, TTMParse, TTMDLG;
{$ENDIF}

const
  ClassName = 'TTMACRO';

const
  Id_CtrlDlg = 100;
  Id_CtrlPauseStart = 101;
  Id_CtrlEnd = 102;
  MsgDdeReady = 21;
  MsgDdeCmndEnd = 22;
  MsgDdeComReady = 23;

type

  PCtrlWindow = ^TCtrlWindow;
  TCtrlWindow = object(TDlgWindow)
    Pause: boolean;
    destructor  Done; virtual;
    procedure SetupWindow; virtual;
    function GetClassName: PChar; virtual;
    procedure GetWindowClass(var AWndClass: TWndClass); virtual;
    procedure WMCommand(var Msg: TMessage);
      virtual wm_First + wm_Command;
    procedure WMTimer(var Msg: TMessage);
      virtual wm_First + wm_Timer;
    procedure WMDdeCmndEnd(var Msg: TMessage);
      virtual wm_User + MsgDdeCmndEnd;
    procedure WMDdeComReady(var Msg: TMessage);
      virtual wm_User + MsgDdeComReady;
    procedure WMDdeReady(var Msg: TMessage);
      virtual wm_User + MsgDdeReady;
  end;

  TCtrlApp = object(TApplication)
    Pause: boolean;
    procedure InitMainWindow; virtual;
    procedure MessageLoop; virtual;
  end;

var
  App: TCtrlApp;

destructor TCtrlWindow.Done;
begin
  EndTTL;

  EndDDE;

  TDlgWindow.Done;
end;

procedure TCtrlWindow.SetupWindow;
var
  TmpDC: HDC;
  Rect: TRect;
  CRTWidth,CRTHeight: integer;
  Temp: array[0..25] of char;
begin
  HWin := HWindow;
  Pause := false;
  TmpDC := GetDC(HWindow);
  CRTWidth := GetDeviceCaps(TmpDC,HORZRES);
  CRTHeight := GetDeviceCaps(TmpDC,VERTRES);
  GetWindowRect(HWindow,Rect);
  ReleaseDC(HWindow, TmpDC);
  SetWindowPos(HWindow,HWND_TOP,
    (CRTWidth-Rect.right+Rect.left) div 2,
    (CRTHeight-Rect.bottom-Rect.top) div 2,
    0,0,SWP_NOSIZE or SWP_NOZORDER);
  TDlgWindow.SetupWindow;

  if not GetFileName then
  begin
    PostQuitMessage(0);
    exit;
  end;
  StrCopy(Temp,'TTMACRO - ');
  StrCat(Temp,ShortName);
  SetWindowText(HWindow,Temp);

  if TopicName[0]<>#0 then InitDDE;

  if not InitTTL then PostQuitMessage(0);
end;

function TCtrlWindow.GetClassName: PChar;
begin
  GetClassName := ClassName;
end;

procedure TCtrlWindow.GetWindowClass(var AWndClass: TWndClass);
begin
  TDlgWindow.GetWindowClass(AWndClass);
  AWndClass.HIcon := LoadIcon(HInstance, PChar(100));
end;

procedure TCtrlWindow.WMCommand(var Msg: TMessage);
begin
  TDlgWindow.WMCommand(Msg);
  case Msg.wParam of
    Id_CtrlPauseStart:
      begin
        if Pause then
          SetDlgItemText(HWindow, Id_CtrlPauseStart, 'Pau&se')
        else
          SetDlgItemText(HWindow, Id_CtrlPauseStart, '&Start');
        Pause := not Pause;
      end;
    Id_CtrlEnd: TTLStatus := IdTTLEnd;
   end;
end;

procedure TCtrlWindow.WMTimer(var Msg: TMessage);
var
  dT: longint;
begin
  KillTimer(HWindow, Msg.wParam);
  LockVar;
  if (Msg.wParam=IdTimeOutTimer) and
     ((TTLStatus=IdTTLWait) or (TTLStatus=IdTTLWait2) or
      (TTLStatus=IdTTLPause)) then
  begin
    dT := TimeLimit-CalcTime;
    if dT>43199 then dT := dT - 86400
    else if dT<-43200 then dT := dT + 86400;

    if dT < 0 then
    begin
      if TTLStatus = IdTTLWait then
        SetResult(0)
      else if TTLStatus = IdTTLWait2 then
      begin
        if Wait2Found then
        begin
          SetInputStr(Wait2Str);
          SetResult(-1)
        end
        else begin
          SetInputStr('');
          SetResult(0);
        end;
      end;
      TTLStatus := IdTTLRun;
    end
    else
      SetTimer(HWindow,IdTimeOutTimer,1000, nil);
  end;
  UnlockVar;
end;

procedure TCtrlWindow.WMDdeCmndEnd(var Msg: TMessage);
begin
  TTLStatus := IdTTLRun;
end;

procedure TCtrlWindow.WMDdeComReady(var Msg: TMessage);
begin
  ComReady := Msg.wParam;
end;

procedure TCtrlWindow.WMDdeReady(var Msg: TMessage);
begin
  if TTLStatus <> IdTTLInitDDE then exit;
  if InitDDE then
    TTLStatus := IdTTLWaitConnect
  else begin
    DispErr(ErrCantConnect);
    TTLStatus := IdTTLRun;
  end
end;

procedure TCtrlApp.InitMainWindow;
begin
  MainWindow := New(PCtrlWindow, Init(nil,PChar(Id_CtrlDlg)));
end;

procedure TCtrlApp.MessageLoop;
var
  Msg: TMsg;
  ResultCode: integer;
begin
  while True do
  begin
    if PeekMessage(Msg, 0, 0, 0, pm_Remove) then
    begin
      if Msg.Message = wm_Quit then
      begin
        Status := Msg.WParam;
        Exit;
      end;
      if not ProcessAppMsg(Msg) then
      begin
        TranslateMessage(Msg);
        DispatchMessage(Msg);
      end;
    end
    else begin
      if OutLen>0 then
        DDESend
      else if not PCtrlWindow(MainWindow)^.Pause and
        (TTLStatus=IdTTLRun) then
        Exec
      else if TTLStatus=IdTTLWait then
      begin
        ResultCode := Wait;
        if ResultCode>0 then
        begin
          KillTimer(MainWindow^.HWindow, IdTimeOutTimer);
          TTLStatus := IdTTLRun;
          LockVar;
          SetResult(ResultCode);
          UnlockVar;
        end;
      end
      else if TTLStatus=IdTTLWait2 then
      begin
        if Wait2 then
        begin
          KillTimer(MainWindow^.HWindow, IdTimeOutTimer);
          TTLStatus := IdTTLRun;
          LockVar;
          SetInputStr(Wait2Str);
          SetResult(1);
          UnlockVar;
        end;
      end
      else if TTLStatus=IdTTLWaitConnect then
      begin
        if ComReady>0 then
          TTLStatus := IdTTLRun;
      end
      else if TTLStatus=IdTTLEnd then
      begin
        if ConvH<>0 then
        begin
          DdeDisconnect(ConvH);
          ConvH := 0;
        end
        else begin
          PostQuitMessage(0);
          TTLStatus:=0;
        end;
      end;

    end;
  end;
end;

begin
  App.Init('TTMACRO');
  App.Run;
  App.Done;
end.