{Tera Term
 Copyright(C) 1994-1996 T. Teranishi
 All rights reserved.}

{TERATERM.EXE, variables, flags related to VT win and TEK win}
unit TTWinMan;

interface
{$I teraterm.inc}

{$IFDEF Delphi}
uses Messages, WinTypes, WinProcs, WinDos, Strings, TTTypes;
{$ELSE}
uses WinTypes, WinProcs, WinDos, Strings, TTTypes;
{$ENDIF}

var
  HMainWin: HWnd;
  HTEKWin: HWnd;

  ActiveWin: integer; {IdVT, IdTEK}
  TalkStatus: integer; {IdTalkKeyb, IdTalkCB, IdTalkTextFile}

  cv: TComVar;
  ts: TTTSet;

  DebugFlag, Connecting: boolean;

  {'help' button on dialog box}
  MsgDlgHelp: word;
  HelpId: longint;

procedure VTActivate;
procedure ChangeTitle;
procedure SwitchMenu;
procedure OpenHelp(HWin: HWND; Command: WORD; Data: longint);

implementation

procedure VTActivate;
begin
  ActiveWin := IdVT;
  ShowWindow(HMainWin, sw_ShowNormal);
  SetFocus(HMainWin);
end;

procedure ChangeTitle;
var
  TempTitle: array[0..80] of char;
begin
  StrCopy(TempTitle, ts.Title);
  StrLCat(TempTitle,' - ',79);
  if Connecting then
    StrLCat(TempTitle,'[connecting...]',79)
  else if not cv.Ready then
    StrLCat(TempTitle,'[disconnected]',79)
  else if ts.PortType=IdSerial then
    case ts.ComPort of
      1: StrLCat(TempTitle,'COM1',79);
      2: StrLCat(TempTitle,'COM2',79);
      3: StrLCat(TempTitle,'COM3',79);
      4: StrLCat(TempTitle,'COM4',79);
    end
  else
    StrLCat(TempTitle,ts.HostName,79);

  StrLCat(TempTitle,' VT',79);
  SetWindowText(HMainWin,TempTitle);
  if HTEKWin<>0 then
  begin
    TempTitle[StrLen(TempTitle)-2] := #0;
    StrLCat(TempTitle,'TEK',79);
    SetWindowText(HTEKWin,TempTitle);
  end;
end;

procedure SwitchMenu;
var
  H1, H2: HWnd;
begin
  if ActiveWin=IdVT then
  begin
    H1 := HTEKWin;
    H2 := HMainWin;
  end
  else begin
    H1 := HMainWin;
    H2 := HTEKWin;
  end;

  if H1<>0 then
    PostMessage(H1,wm_user+MsgChangeMenu,0,0);
  if H2<>0 then
    PostMessage(H2,wm_user+MsgChangeMenu,0,0);
end;

procedure OpenHelp(HWin: HWND; Command: WORD; Data: longint);
var
  HelpFN: array[0..MAXPATHLEN-1] of char;
begin
  strcopy(HelpFN,ts.HomeDir);
  strcat(HelpFN,'\');
  if ts.Language=IdEnglish then
    strcat(HelpFN,HelpEng)
  else
    strcat(HelpFN,HelpJpn);
  WinHelp(HWin, HelpFN, Command, Data);
end;

begin
  HTEKWin := 0;
  Connecting := false;
  cv.Open := false;
  cv.Ready := false;
  TalkStatus := IdTalkKeyb;
end.